package ui

import (
	"os"

	"gioui.org/app"
	"github.com/rs/zerolog/log"
)

// Init initializes and runs the UI.
func Init() {
	go func() {
		window := new(app.Window)
		err := run(window)
		if err != nil {
			log.Fatal().Err(err).Msg("UI loop exited with error")
		}
		os.Exit(1)
	}()
	app.Main()
}
